package quimufu.colourful_portals.mixin.client;

import net.minecraft.client.resource.metadata.AnimationResourceMetadata;
import net.minecraft.client.texture.SpriteContents;
import net.minecraft.client.texture.SpriteDimensions;
import org.jetbrains.annotations.Nullable;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.Unique;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import quimufu.colourful_portals.client.AlphaInterpolationHolder;

@Mixin(SpriteContents.class)
public abstract class SpriteContentsMixin {

    @Unique
    private final ThreadLocal<Boolean> redirect = ThreadLocal.withInitial(() -> true);

    @Shadow
    @Final
    @Nullable
    private SpriteContents.@Nullable Animation animation;

    @Shadow
    public abstract boolean isPixelTransparent(int frame, int x, int y);

    @Inject(at = @At("RETURN"), method = "createAnimation(Lnet/minecraft/client/texture/SpriteDimensions;IILnet/minecraft/client/resource/metadata/AnimationResourceMetadata;)Lnet/minecraft/client/texture/SpriteContents$Animation;", cancellable = true)
    void passInterpolateAlpha(SpriteDimensions dimensions, int imageWidth, int imageHeight, AnimationResourceMetadata metadata, CallbackInfoReturnable<AlphaInterpolationHolder> cir) {
        AlphaInterpolationHolder returnValue = cir.getReturnValue();
        if (returnValue != null) {
            returnValue.colourful_portals$setInterpolateAlpha(((AlphaInterpolationHolder) metadata).colourful_portals$isInterpolateAlpha());
            cir.setReturnValue(returnValue);
            cir.cancel();
        }
    }

    @Inject(at = @At("RETURN"), method = "isPixelTransparent(III)Z", cancellable = true)
    void correctIsPixelTransparent(int frame, int x, int y, CallbackInfoReturnable<Boolean> cir) {
        if (redirect.get() && animation != null && ((AlphaInterpolationHolder) animation).colourful_portals$isInterpolateAlpha()) {
            redirect.set(false);
            cir.setReturnValue(this.isPixelTransparent(frame, x, y) || this.isPixelTransparent(frame + 1, x, y));
            redirect.set(true);
            cir.cancel();
        }
    }

}
